package com.example.quiz;

import android.app.AlertDialog;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Build;
import android.os.Bundle;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.fragment.app.Fragment;
import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import android.os.Handler;
import android.os.Looper;
import android.os.RemoteException;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.example.quiz.data.model.enums.TypeProduits;
import com.example.quiz.databinding.FragmentRaceReportBinding;
import com.example.quiz.utils.BitMapUtils;
import com.example.quiz.utils.LoaderDialog;
import com.example.quiz.utils.MessageDialog;
import com.example.quiz.utils.MobiIotPrinterManager;
import com.example.quiz.utils.Result;
import com.example.quiz.utils.SunmiPrinterManager;
import com.example.quiz.viewModel.RapportCourseViewModel;

import dagger.hilt.android.AndroidEntryPoint;

/**
 * A simple {@link Fragment} subclass.
 * Use the {@link RaceReport#newInstance} factory method to
 * create an instance of this fragment.
 */
@AndroidEntryPoint
public class RaceReport extends Fragment {

    FragmentRaceReportBinding binding;

    SunmiPrinterManager sunmiPrinterManager;

    String mobileName;

    MutableLiveData<Boolean> isPrinterReady = new MutableLiveData<>(false);

    LoaderDialog loader;

    RapportCourseViewModel rapportCourseViewModel;


    public RaceReport() {
        // Required empty public constructor
    }

    // TODO: Rename and change types and number of parameters
    public static RaceReport newInstance() {
        RaceReport fragment = new RaceReport();
        Bundle args = new Bundle();
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        rapportCourseViewModel = new ViewModelProvider(this).get(RapportCourseViewModel.class);
        loader = new LoaderDialog(getContext());
        mobileName = Build.MANUFACTURER;
        sunmiPrinterManager = SunmiPrinterManager.getInstance(requireContext());
        if(mobileName.toLowerCase().contains("sunmi")){
            sunmiPrinterManager.connectPrinter(status -> {
                isPrinterReady.setValue(status);
                sunmiPrinterManager.disableSystemMessages();
            });
        }else{
            MobiIotPrinterManager.getInstance().init(requireContext());
        }
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        binding = FragmentRaceReportBinding.inflate(inflater, container, false);
        // Inflate the layout for this fragment
        return binding.getRoot();
    }

    @Override
    public void onViewCreated(@NonNull View view, @Nullable Bundle savedInstanceState) {
        super.onViewCreated(view, savedInstanceState);
        binding.btnCheckBalance.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                if(binding.etRaceNumber.getText().toString().isEmpty()){
                    binding.etRaceNumber.setError("Veuillez entrer un numéro de course");
                    return;
                }
                rapportCourseViewModel.getRaceReport(binding.etRaceNumber.getText().toString()).observe(getViewLifecycleOwner(), new Observer<Result<com.example.quiz.data.model.RaceReport>>() {
                    @Override
                    public void onChanged(Result<com.example.quiz.data.model.RaceReport> raceReportResult) {
                        switch (raceReportResult.status){
                            case LOADING:{
                                loader.show("Chargement du rapport");
                                break;
                            }
                            case ERROR:{
                                loader.dismiss();
                                MessageDialog.showError(getContext(), raceReportResult.message);
                                break;
                            }
                            case SUCCESS:{
                                loader.dismiss();
                                new AlertDialog.Builder(getContext()).setTitle("Rapport")
                                        .setMessage("Voulez-vous imprimer le rapport ?")
                                        .setPositiveButton("Oui", (dialog, which) -> {
                                            try {
                                                printRapport(raceReportResult.data);
                                                dialog.dismiss();
                                            } catch (RemoteException e) {
                                                throw new RuntimeException(e);
                                            }
                                        })
                                        .setNegativeButton("Non", (dialog, which) -> {
                                            dialog.dismiss();
                                        }).show();
                                break;
                            }
                        }
                    }
                });
            }
        });
    }

    void printRapport(com.example.quiz.data.model.RaceReport report) throws RemoteException {
        Bitmap logo = BitmapFactory.decodeResource(getResources(), R.drawable.pmu_logo);
        String courseCode = report.getCodeCourse()+" "+report.getDateCourse();
        String hippodomeName = report.getHippodrome();
        String courseName = report.getNomCourse() != null?report.getNomCourse().toUpperCase():"Non défini";
        String arrivee = report.getArrivee();
        String nonPartants = !report.getNonPartants().equals("néant".toUpperCase())?report.getNonPartants():" ";
        StringBuilder text = new StringBuilder();
        if(report.getDetailsGagnantsGroupes().get(TypeProduits.QUINTE) != null && report.getDetailsGagnantsGroupes().get(TypeProduits.QUINTE).size() > 0){
            text.append("Quinté+").append("\n");
            report.getDetailsGagnantsGroupes().get(TypeProduits.QUINTE).forEach((item)->{
                text.append(item.getLibelle()).append(" : ").append(BitMapUtils.formatMontant(item.getMassePayee())).append(" XOF").append("\n");
            });
            text.append("\n");
        }
        if(report.getDetailsGagnantsGroupes().get(TypeProduits.QUARTE) != null && report.getDetailsGagnantsGroupes().get(TypeProduits.QUARTE).size() > 0){
            text.append("Quarté").append("\n");
            report.getDetailsGagnantsGroupes().get(TypeProduits.QUARTE).forEach((item)->{
                text.append(item.getLibelle()+" : ").append(BitMapUtils.formatMontant(item.getMassePayee())).append(" XOF").append("\n");
            });
            text.append("\n");
        }
        if(report.getDetailsGagnantsGroupes().get(TypeProduits.TIERCE) != null && report.getDetailsGagnantsGroupes().get(TypeProduits.TIERCE).size() > 0){
            text.append("Tiercé").append("\n");
            report.getDetailsGagnantsGroupes().get(TypeProduits.TIERCE).forEach((item)->{
                text.append(item.getLibelle()+" : ").append(BitMapUtils.formatMontant(item.getMassePayee())).append(" XOF").append("\n");
            });
            text.append("\n");
        }
        if(report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_GAGNANT) != null && report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_GAGNANT).size() > 0){
            text.append("Couplé gagnant").append("\n");
            report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_GAGNANT).forEach((item)->{
                text.append(item.getLibelle()+" : ").append(BitMapUtils.formatMontant(item.getMassePayee())).append(" XOF").append("\n");
            });
            text.append("\n");
        }
        if(report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_PLACE) != null && report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_PLACE).size() > 0){
            text.append("Couplé placé").append("\n");
            report.getDetailsGagnantsGroupes().get(TypeProduits.COUPLE_PLACE).forEach((item)->{
                text.append(item.getLibelle()+" : ").append(BitMapUtils.formatMontant(item.getMassePayee())).append(" XOF").append("\n");
            });
            text.append("\n");
        }
        if(mobileName.toLowerCase().contains("sunmi")){
            if(isPrinterReady.getValue() == null || !isPrinterReady.getValue()){
                sunmiPrinterManager.connectPrinter(status ->{
                    isPrinterReady.setValue(status);
                });
            }
            if(sunmiPrinterManager.printerStatus() != 1){
                MessageDialog.showError(getContext(), "Erreur lors de l'impréssion, Veuillez rééssayer S.V.P!");
                return;
            }
            sunmiPrinterManager.printRapport(BitMapUtils.resizeToPrinterWidth(logo, 384), courseCode, hippodomeName, courseName, arrivee, nonPartants, text, new SunmiPrinterManager.PrintStatusListener() {
                @Override
                public void onStatusChanged(boolean status) {
                    new Handler(Looper.getMainLooper()).post(new Runnable() {
                        @Override
                        public void run() {
                            if(!status){
                                MessageDialog.showError(getContext(), "Erreur lors de l'impréssion, Veuillez rééssayer S.V.P!");
                                return;
                            }
                            MessageDialog.showSuccess(getContext(), "Rapport imprimé avec succès");
                        }
                    });
                }
            });
        }else{
            if(MobiIotPrinterManager.getInstance().getPrinterStatus() != 1){
                MessageDialog.showError(getContext(), "Erreur lors de l'impréssion, Veuillez rééssayer S.V.P!");
                return;
            }
            MobiIotPrinterManager.getInstance().printRapport(BitMapUtils.bitmapToBmp(BitMapUtils.resizeToPrinterWidth(logo, 384)), courseCode, hippodomeName, courseName, arrivee, nonPartants, text, new MobiIotPrinterManager.MobiIotPrinterStatus() {
                @Override
                public void printStatusCode(int status) {
                    new Handler(Looper.getMainLooper()).post(new Runnable() {
                        @Override
                        public void run() {
                            if(status == 1 ){
                                MessageDialog.showSuccess(getContext(), "Rapport imprimé avec succès");
                            }else{
                                MessageDialog.showError(getContext(), "Erreur lors de l'impréssion, Veuillez rééssayer S.V.P!");
                            }
                        }
                    });

                }
            });
        }
    }
}